      //FILE: load.js
      //PURPOSE: loading SM
      //EXPORT: loadTango()
      //NOTE: all expected customization should be limited to
      //      the error handling function fail()
      //NOTE: this page is not MS IE safe


      ns4 = (document.layers)? true:false;
      ie4 = (document.all)? true:false;

      //function: print()
      //scope: local
      //purpose: logs messages on the Java console
      //param: s - message
      //return: void
      function print(s)
      {
	if(ns4)
	  java.lang.System.out.println("load.js: "+s)
      }// print ____________________________________________________________


      //function: fail()
      //scope: local
      //purpose: called when inappropriate environment is detected
      //param: m - error message
      //return: void
      function fail(m)
      {
        print(m);
        //here follow options of handling errors:
        alert("TANGO: "+m);
        //document.writeln("improper environment detected: "+m);
        //top.location.href="..";
        //history.back();
      }// fail _____________________________________________________________


      //function: startTango()
      //scope: local
      //purpose: proper load; opens new window with SM
      //param: smUrl - URL of a page including SM
      //param: ypos,xpos - position of the window (-1 for auto)
      //param: ysiz,xsiz - size of the window
      //param: startedUrl - URL which should be shown when Tango started
      //                    no page change if null
      //return: void
      function startTango(smUrl,ypos,xpos,ysiz,xsiz,startedUrl)
      {
        print("loading SM ...");
	if((ypos==-1)||(xpos==-1))
          window.open(smUrl,"tsm","toolbar=no,location=no,directories=no,status=no,menubar=no,resizable=no,scrollbars=no,width="+xsiz+",height="+ysiz);
	else
          window.open(smUrl,"tsm","toolbar=no,location=no,directories=no,status=no,menubar=no,resizable=no,scrollbars=no,width="+xsiz+",height="+ysiz+",screenX="+xpos+",screenY="+ypos+",left="+xpos+",top="+ypos);
        if(startedUrl)
          top.location.href=startedUrl;
      }// startTango _______________________________________________________


      //functiok: checkJava()
      //scope: local
      //purpose: tests if Java enabled
      //param: troubleUrl - URL of a page that shows when wrong env
      //return: true if Java is enabled
      function checkJava(troubleUrl)
      {
        if(!navigator.javaEnabled())
        {
          //fail("Java not enabled");
          top.location.href=troubleUrl;
          return false;
        }
        return true;
      }// checkJava ________________________________________________________


      //function: checkBrowser()
      //scope: local
      //purpose: tests if we are in the specified browser
      //param: browserName - distinctive part of the string navigator.appName
      //param: majVersion,minVersion - minimum version requirements
      //param: troubleUrl - URL of a page that shows when wrong env
      //return: true if the browser complies with the given specification
      function checkBrowser(browserName,majVersion,minVersion,troubleUrl)
      {
        browser=navigator.appName;
        //print("navigator.appName: \'"+browser+"\'");
        //print("navigator.appVersion: \'"+navigator.appVersion+"\'");
        if(browser.indexOf(browserName)>=0)
        {
          //print("browser ok: \'"+browser+"\'==\'"+browserName+"\'");
          verS=navigator.appVersion;
          if(verS.substring(0,verS.indexOf(" "))=="4.6")
          {
            print("unsupported browser version: \'"+verS+"\' (Netscape LifeConnect bug)");
            fail(""+browserName+" browser, version "+majVersion+"."+minVersion+" at least but not 4.6 is required!");
            top.location.href=troubleUrl;
            return false;
          }
          dotIdx=verS.indexOf(".");
          majVer=parseInt(verS.substring(0,dotIdx));
          //print("dotIdx="+dotIdx+" majVer="+majVer);
          if(majVer>majVersion)
          {
            //print("major version number ok: "+majVer+">"+majVersion);
            return true;
          }
          else if(majVer==majVersion)
          {
            //print("major version number ok: "+majVer+"=="+majVersion);
            minVer=parseInt(verS.substring(dotIdx+1,verS.length));
            minVer=0;
            minVerS=verS.substring(dotIdx+1,verS.length);
            //print("dotIdx="+dotIdx+" minVerS="+minVerS);
            if(((minVerS.length)>1)&&((minVerS.indexOf("0"))==0))
              minVer=parseInt(minVerS.substring(1,minVerS.length))/10.0;
            else
            {
              minVer=parseInt(minVerS);
              if(minVer>=10)
                minVer=minVer/10.0;
            }
            //print("minVer="+minVer);
            if(minVer>=minVersion)
            {
              //print("minor version number ok: "+minVer+">="+minVersion);
              return true;
            }
            else
            {
              print("insufficient minor version number: "+minVer);
              fail(""+browserName+" browser, version "+majVersion+"."+minVersion+" is required at least! (but not 4.6)");
              top.location.href=troubleUrl;
              return false;
            }
          }
          else 
          {
            print("insufficient major version number: "+majVer);
            fail(""+browserName+" browser, version "+majVersion+"."+minVersion+" is required at least! (but not 4.6)");
            top.location.href=troubleUrl;
            return false;
          }
        }
        else
        {
          print("unsupported browser: \'"+browser+"\'");
          fail(""+browserName+" browser required! (v."+majVersion+"."+minVersion+" at least, but not 4.6)");
          top.location.href=troubleUrl;
          return false;
        }
      }// checkBrowser _____________________________________________________


      //function: checkPlugin()
      //scope: local
      //purpose: tests if the right plugin is installed
      //param: pluginMime - MIME type of the plugin
      //param: pluginName - string navigator.plugins[{pluginName}].name
      //                    same as plugin title in Help/AboutPlugins menu
      //return: true if the specified plugin is installed and enabled
      function checkPlugin(pluginMime,pluginName,pluginVersion,
                           downloadUrl,upgradeRootUrl)
      {
        var reqNam=pluginName+" [v. "+pluginVersion+"]";
        var mim=navigator.mimeTypes[pluginMime]
        if(mim)
        {
          print("mime ok: \'"+pluginMime+"\'");
          var plg=mim.enabledPlugin;
          if(plg)
          {
            print("required plugin: \'"+reqNam+"\'");
            var actNam=plg.name;
            print("actual plugin: \'"+actNam+"\'");
            if(actNam.indexOf(pluginName)!=-1)
            {
              var s=pluginVersion;var i=s.indexOf(".");
              var reqVer1=s.substring(0,i);
              s=s.substring(i+1,s.length);i=s.indexOf(".");
              var reqVer2=s.substring(0,i);
              s=s.substring(i+1,s.length);i=s.indexOf(".");
              var reqVer3=s.substring(0,i);
              var reqVer4=s.substring(i+1,s.length);
              print("required plugin version: "+reqVer1+"."+reqVer2+"."+
                                                reqVer3+"."+reqVer4);

              s=actNam;i=s.indexOf("[v. ")+4;
              s=s.substring(i,s.length-1);i=s.indexOf(".");
              var actVer1=s.substring(0,i);
              s=s.substring(i+1,s.length);i=s.indexOf(".");
              var actVer2=s.substring(0,i);
              s=s.substring(i+1,s.length);i=s.indexOf(".");
              var actVer3=s.substring(0,i);
              var actVer4=s.substring(i+1,s.length);
              print("actual plugin version: "+actVer1+"."+actVer2+"."+
                                              actVer3+"."+actVer4);

              if((actVer1==reqVer1)&&(actVer2==reqVer2))
              {
                if((actVer3>reqVer3)||
                   ((actVer3==reqVer3)&&(actVer4>=reqVer4)))
                {
                  //print("plugin ok: \'"+actNam+"\'");
                  return true;
                }
                else
                {
                  print("old version of plugin installed: \'"+actNam+"\'");
                  if(confirm("You have \'"+actNam+"\' plugin."+
                             "\nDo you want to upgrade to \'"+reqNam+"\'?"))
                  {
                    upgradePlugin(downloadUrl,upgradeRootUrl,pluginVersion);
                    return false;
                  }
                  else
                    return true;
                }
              }
              else if((actVer1>reqVer1)||
	              ((actVer1==reqVer1)&&(actVer2>reqVer2)))
              {
                //print("plugin ok: \'"+actNam+"\'");
                return true;
              }
              else
              {
                print("incompatible version of plugin installed: \'"+actNam+"\'");
                fail("You have "+actNam+" plugin. You must upgrade to "+reqNam+"!");
                upgradePlugin(downloadUrl,upgradeRootUrl,pluginVersion);
                return false;
              }
            }
            else 
            {
              print("wrong plugin installed: \'"+actNam+"\'");
              fail("Wrong plugin is installed!");
              upgradePlugin(downloadUrl,upgradeRootUrl,pluginVersion);
              return false;
            }
          }
          else
          {
            if(navigator.plugins[reqNam])
            {
              print("plugin \'"+reqNam+"\' disabled");
              fail("Plugin \'"+reqNam+"\' is disabled!");
              upgradePlugin(downloadUrl,upgradeRootUrl,pluginVersion);
              return false;
              //print("plugin \'"+reqNam+"\' seems to be disabled, ignoring");
              //return true;
            }
            else
            {
              print("plugin \'"+pluginName+"\' not installed");
              fail("Plugin \'"+pluginName+"\' is not installed!");
              upgradePlugin(downloadUrl,upgradeRootUrl,pluginVersion);
              return false;
            }
          }
        }
        else
        {
          print("mime \'"+pluginMime+"\' not supported");
          fail("\'"+pluginMime+"\' plugin is not installed!"+
               "You need \'"+reqNam+"\' plugin.");
          //upgradePlugin(downloadUrl,upgradeRootUrl,pluginVersion);
          top.location.href=downloadUrl;
          return false;
        }
      }// checkPlugin ______________________________________________________


      //function: upgradePlugin()
      //scope: local
      //purpose: opens proper installation package
      //param: downloadUrl - URL of the general download page
      //param: upgradeRootUrl - URL of the root directory
      //                        for installation packages
      //param: pluginVersion - desired plugin version (e.g. "1.4.0.1")
      //return: void
      function upgradePlugin(downloadUrl,upgradeRootUrl,pluginVersion)
      {
        var navVer=navigator.appVersion;
        //print("navigator.appVersion="+navVer);
        //4.5 [en] (X11; I; IRIX64 6.2 IP25; Nav)
        //print("navigator.userAgent="+navigator.userAgent);
        if(navVer.indexOf("X11")!=-1)
        {
          print("operating system: Unix");
          if(navVer.indexOf("IRIX 6.5")!=-1)
            v="irix65";
          else if(navVer.indexOf("IRIX 6.3")!=-1)
            v="irix63";
          else if(navVer.indexOf("IRIX")!=-1)
            v="irix";
          else if(navVer.indexOf("Linux")!=-1)
            v="linux";
          else if(navVer.indexOf("SunOS")!=-1)
            v="sunos";
          else
          {
            print("unrecognized opearting system: "+navVer);
            fail("Unrecognized version of the operating system!"+
                 "\nSupported systems include: Linux, SunOS, IRIX, Windows.");
            top.location.href=downloadUrl;
          }
          print("opearting system: "+v);
          var h=upgradeRootUrl+"tango-client-"+pluginVersion+"-"+v+".tar.gz";
          print("downloading: "+h);
          top.location.href=h;
        }
        else if(navVer.indexOf("Win")!=-1)
        {
          print("operating system: Windows");
          var h=upgradeRootUrl+"tango-client-"+pluginVersion+"-win.exe";
          print("downloading: "+h);
          top.location.href=h;
        }
        else
        {
          print("unrecognized operating system: "+navVer);
          fail("Unexpected operating system!");
          top.location.href=downloadUrl;
        }
      }// upgradePlugin ____________________________________________________


      //function: loadTango()
      //scope: export
      //purpose: tests environment and loads Tango
      //param: mimeType - plugin required mime type
      //param: pluginName - plugin required name
      //param: pluginVersion - plugin required version
      //                       (usually also a part of pluginName)
      //param: smUrl - page with sm
      //param: ypos,xpos - position of the SM window (-1 for auto)
      //param: ysiz,xsiz - size of the SM window
      //param: troubleUrl - environment troubleshooting page
      //                    (browser brand and version, Java enabled)
      //param: startedUrl - the page to replace the current page
      //                    when sm succesfully loaded
      //param: downloadUrl - plugin download page
      //                     (if not qualifies for upgrade)
      //param: upgradeUrl - directory with upgrades
      //                    (must end with /)
      //return: void
      function loadTango(browser,majorVersion,minorVersion,
                         mimeType,pluginName,pluginVersion,
	                 smUrl,ypos,xpos,ysiz,xsiz,
                         startedUrl,troubleUrl,downloadUrl,upgradeUrl)
      {
	if(browser=="Netscape"){
          if(checkJava(troubleUrl)&&
             checkBrowser(browser,majorVersion,minorVersion,troubleUrl)&&
             checkPlugin(mimeType,pluginName,pluginVersion,
             downloadUrl,upgradeUrl))
            startTango(smUrl,ypos,xpos,ysiz,xsiz,startedUrl);
          else
            print("quitting tango.");
          }
        else
          startTango(smUrl,ypos,xpos,ysiz,xsiz,startedUrl);
      }// loadTango ________________________________________________________


